# # -*- coding: utf-8 -*-
# """
# Created on Fri Apr 28 11:40:32 2023

# @author: 2020033001
# """
# # from zipline.pipeline import Pipeline, CustomFactor
from zipline.pipeline.data import Column, DataSet, DataSetFamily
from zipline.pipeline.domain import Domain,TW_EQUITIES
import os 
from typing import Literal
import json
# current directory
# module_dir = os.path.dirname(os.path.abspath(__file__))
# json_path = os.path.join(module_dir,'TQDataSet.json')

# Read JSON file
# with open(json_path, 'r') as json_file:
#     data = json.load(json_file)
#     json_file.close()

class TQData(DataSetFamily):
    # 20231208 新增fin_order
    fin_order = Column(float)
    lag_fin_date = Column('datetime64[ns]')

    # TQDataSet
    domain = TW_EQUITIES
    symbol = Column(object)
    date = Column('datetime64[ns]')
    # Dividend_Yield_TWSE = Column(float)
    # Cash_Dividend_Yield_TEJ = Column(float)
    # Adjust_Factor = Column(float)
    # Transaction = Column(float)
    # # Common_Stock_Shares_Issued_Thousand_Shares = Column(float)
    # Issue_Shares_1000_Shares = Column(float)
    # PBR_TEJ = Column(float)
    # Low = Column(float)
    # PER_TWSE = Column(float)
    # Adjust_Factor_Exclude_CashDiv = Column(float)
    # Close = Column(float)
    # Market_Cap_Percentage = Column(float)
    # Open = Column(float)
    # PBR_TWSE = Column(float)
    # Last_Bid = Column(float)
    # Value_Dollars = Column(float)
    # High_Low_Diff = Column(float)
    # Average_Trade_Price = Column(float)
    # Trade_Value_Percentage = Column(float)
    # High = Column(float)
    # # Listing_Type = Column(object)
    # ROI = Column(float)
    # Turnover = Column(float)
    # PER_TEJ = Column(float)
    # Last_Offer = Column(float)
    # PSR_TEJ = Column(float)
    # Market_Cap_Dollars = Column(float)
    # Volume_1000_Shares = Column(float)
    # Component_Stock_of_High_Dividend_Fg = Column(object)
    # Matching_Period = Column(float)
    # Industry = Column(object)
    # Industry_Eng = Column(object)
    # Sub_Industry = Column(object)  # 20231108
    # Sub_Industry_Eng = Column(object) # 20231108
    # Security_Type_English = Column(object)
    # Component_Stock_of_MSCI_TW_Fg = Column(object)
    # Suspended_Trading_Stock_Fg = Column(object)
    # Attention_Stock_Fg = Column(object)
    # Component_Stock_of_MidCap100_Fg = Column(object)
    # Limit_Up_or_Down_in_Opening_Fg = Column(object)
    # Market_Board = Column(object)
    # Market_Board_Eng = Column(object)
    # Security_Type_Chinese = Column(object)
    # Suspension_of_Buy_After_Day_Trading_Fg = Column(object)
    # Limit_Up_or_Down = Column(object)
    # Component_Stock_of_TPEx200_Fg = Column(object)
    # Disposition_Stock_Fg = Column(object)
    # Full_Delivery_Stock_Fg = Column(object)
    # Component_Stock_of_TPEx50_Fg = Column(object)
    # Component_Stock_of_TWN50_Fg = Column(object)
    # Dealer_Hedge_Diff_Amt = Column(float)
    # Total_Sell_Amt = Column(float)
    # Margin_Day_Trading_Amt = Column(float)
    # Total_Buy_Vol = Column(float)
    # Fund_Sell_Vol = Column(float)
    # Fund_Stock_Holding_Pct = Column(float)
    # Dealer_Proprietary_Diff_Vol = Column(float)
    # Dealer_Proprietary_Sell_Vol = Column(float)
    # Margin_Short_Balance_Vol = Column(float)
    # Margin_Short_Maintenance_Ratio = Column(float)
    # SBL_Short_Returns_Vol = Column(float)
    # Fund_Buy_Vol = Column(float)
    # SBL_Short_Balance_Amt = Column(float)
    # Fund_Diff_Amt = Column(float)
    # SBL_Short_Sales_Vol = Column(float)
    # Qfii_Stock_Holding_Pct = Column(float)
    # Fund_Diff_Vol = Column(float)
    # Cash_Redemption = Column(float)
    # Dealer_Hedge_Diff_Vol = Column(float)
    # Dealer_Stock_Holding_Pct = Column(float)
    # SBL_Short_Balance_Vol = Column(float)
    # Fund_Sell_Amt = Column(float)
    # Margin_Purchase = Column(float)
    # Qfii_Diff_Vol = Column(float)
    # Total_Buy_Amt = Column(float)
    # Margin_Short_Balance_Amt = Column(float)
    # Margin_Short_Sales = Column(float)
    # Margin_Short_Quota = Column(float)
    # SBL_Short_Quota = Column(float)
    # Fund_Buy_Amt = Column(float)
    # Margin_Day_Trading_Vol = Column(float)
    # Total_Diff_Amt = Column(float)
    # Total_Sell_Vol = Column(float)
    # Dealer_Hedge_Buy_Vol = Column(float)
    # Qfii_Sell_Amt = Column(float)
    # Dealer_Hedge_Sell_Amt = Column(float)
    # SBL_Short_Sales_Amt = Column(float)
    # Dealer_Proprietary_Diff_Amt = Column(float)
    # Margin_Maintenance_Ratio = Column(float)
    # Qfii_Buy_Vol = Column(float)
    # Dealer_Proprietary_Sell_Amt = Column(float)
    # Dealer_Hedge_Buy_Amt = Column(float)
    # Margin_Short_Coverting = Column(float)
    # Day_Trading_Volume_1000_Shares = Column(float)
    # Dealer_Proprietary_Buy_Amt = Column(float)
    # Margin_Balance_Amt = Column(float)
    # Qfii_Buy_Amt = Column(float)
    # Qfii_Sell_Vol = Column(float)
    # Margin_Stock_Redemtion = Column(float)
    # Qfii_Diff_Amt = Column(float)
    # Account_Maintenance_Ratio = Column(float)
    # Margin_Quota = Column(float)
    # Margin_Balance_Vol = Column(float)
    # Margin_Balance_Ratio = Column(float)
    # Total_Diff_Vol = Column(float)
    # Day_Trading_Pct = Column(float)
    # Margin_Sale = Column(float)
    # Dealer_Proprietary_Buy_Vol = Column(float)
    # Dealer_Hedge_Sell_Vol = Column(float)
    # Custodied_Lots_Between_400_600_Pct = Column(float)
    # Custodied_Larger_Than_400_Lots_Total_Lots = Column(float)
    # Custodied_Greater_Than_1000_Lots_Total_Lots = Column(float)
    # Custodied_Lots_Between_800_1000_Total_Holders = Column(float)
    # Custodied_Lots_Between_600_800_Total_Holders = Column(float)
    # Pledged_Stock_Shares_1000_Lots = Column(float)
    # Custodied_Greater_Than_1000_Lots_Pct = Column(float)
    # Custodied_Lots_Between_600_800_Pct = Column(float)
    # Custodied_Lots_Between_800_1000_Total_Lots = Column(float)
    # Total_Custodied_Shares_1000_Lots = Column(float)
    # Custodied_Larger_Than_400_Lots_Total_Holders = Column(float)
    # Custodied_Larger_Than_400_Lots_Pct = Column(float)
    # Custodied_Under_400_Lots_Pct = Column(float)
    # Custodied_Greater_Than_1000_Lots_Total_Holders = Column(float)
    # Custodied_Under_400_Lots_Total_Holders = Column(float)
    # Custodied_Lots_Between_800_1000_Pct = Column(float)
    # Custodied_Lots_Between_600_800_Total_Lots = Column(float)
    # Custodied_Under_400_Lots_Total_Lots = Column(float)
    # Custodied_Lots_Between_400_600_Total_Lots = Column(float)
    # Custodied_Lots_Between_400_600_Total_Holders = Column(float)
    # Sales_Accu_LastYear = Column(float)
    # Outstanding_Shares_1000_Shares = Column(float)
    # MoM_Monthly_Sales = Column(float)
    # Sales_Per_Share_Accu = Column(float)
    # Month_Sales_Compared_To_Lowest_Month_Sales_MoM = Column(float)
    # YoY_Accu_Sales_3M = Column(float)
    # Lowest_Monthly_Sales_YM = Column('datetime64[ns]')
    # YoY_AccuSales_12M = Column(float)
    # Sales_Monthly = Column(float)
    # MoM_Accu_Sales_3M = Column(float)
    # Sales_Per_Share_Single_Month = Column(float)
    # Highest_Or_Lowest_In_12M = Column(object)
    # Hit_New_High_Or_Low_In_N_Months = Column(float)
    # Sales_Per_Share_Accu_3M = Column(float)
    # Sales_Accu_3M = Column(float)
    # Highest_Or_Lowest_Same_Month = Column(object)
    # Highest_Monthly_Sales_YM = Column('datetime64[ns]')
    # Month_Sales_Compared_To_High_Month_Sales_MoM = Column(float)
    # Lowest_Monthly_Sales = Column(float)
    # Highest_Monthly_Sales = Column(float)
    # Sales_Accu_3M_LastYear = Column(float)
    # Sales_Accumulated = Column(float)
    # YoY_Accu_Sales = Column(float)
    # Sales_Accu_12M_Last_Year = Column(float)
    # Sales_Accu_12M = Column(float)
    # Sales_Per_Share_Accu_12M = Column(float)
    # Highest_Or_Lowest_All_Time = Column(object)
    # YoY_Monthly_Sales = Column(float)
    # QoQ_Accu_Sales_3M = Column(float)
    # Sales_Monthly_LastYear = Column(float)
    Operating_Income_Rate_percent_A = Column(float)
    Operating_Income_Rate_percent_Q = Column(float)
    Operating_Income_Rate_percent_TTM = Column(float)
    Gross_Margin_Growth_Rate_A = Column(float)
    Gross_Margin_Growth_Rate_Q = Column(float)
    Gross_Margin_Growth_Rate_TTM = Column(float)
    Net_Income_Loss_A = Column(float)
    Net_Income_Loss_Q = Column(float)
    Net_Income_Loss_TTM = Column(float)
    Pre_Tax_Income_Growth_Rate_A = Column(float)
    Pre_Tax_Income_Growth_Rate_Q = Column(float)
    Pre_Tax_Income_Growth_Rate_TTM = Column(float)
    Net_Operating_Income_Loss_A = Column(float)
    Net_Operating_Income_Loss_Q = Column(float)
    Net_Operating_Income_Loss_TTM = Column(float)
    Profit_Before_Tax_A = Column(float)
    Profit_Before_Tax_Q = Column(float)
    Profit_Before_Tax_TTM = Column(float)
    Net_Income_Rate_percent_A = Column(float)
    Net_Income_Rate_percent_Q = Column(float)
    Net_Income_Rate_percent_TTM = Column(float)
    Net_Income_Attributable_to_Parent_A = Column(float)
    Net_Income_Attributable_to_Parent_Q = Column(float)
    Net_Income_Attributable_to_Parent_TTM = Column(float)
    Operating_Income_Growth_Rate_A = Column(float)
    Operating_Income_Growth_Rate_Q = Column(float)
    Operating_Income_Growth_Rate_TTM = Column(float)
    Gross_Profit_Loss_from_Operations_A = Column(float)
    Gross_Profit_Loss_from_Operations_Q = Column(float)
    Gross_Profit_Loss_from_Operations_TTM = Column(float)
    Total_Operating_Income_A = Column(float)
    Total_Operating_Income_Q = Column(float)
    Total_Operating_Income_TTM = Column(float)
    Pre_Tax_Income_Rate_percent_A = Column(float)
    Pre_Tax_Income_Rate_percent_Q = Column(float)
    Pre_Tax_Income_Rate_percent_TTM = Column(float)
    Net_Income_Per_Share_A = Column(float)
    Net_Income_Per_Share_Q = Column(float)
    Net_Income_Per_Share_TTM = Column(float)
    Pre_Tax_Income_Per_Share_A = Column(float)
    Pre_Tax_Income_Per_Share_Q = Column(float)
    Pre_Tax_Income_Per_Share_TTM = Column(float)
    Basic_Earnings_Per_Share_A = Column(float)
    Basic_Earnings_Per_Share_Q = Column(float)
    Basic_Earnings_Per_Share_TTM = Column(float)
    Net_Income_Growth_Rate_A = Column(float)
    Net_Income_Growth_Rate_Q = Column(float)
    Net_Income_Growth_Rate_TTM = Column(float)
    Sales_Growth_Rate_A = Column(float)
    Sales_Growth_Rate_Q = Column(float)
    Sales_Growth_Rate_TTM = Column(float)
    Gross_Margin_Rate_percent_A = Column(float)
    Gross_Margin_Rate_percent_Q = Column(float)
    Gross_Margin_Rate_percent_TTM = Column(float)
    Total_Equity_A = Column(float)
    Total_Equity_Q = Column(float)
    Total_Equity_TTM = Column(float)
    Total_Non_Current_Assets_A = Column(float)
    Total_Non_Current_Assets_Q = Column(float)
    Total_Non_Current_Assets_TTM = Column(float)
    Advances_Receipts_Non_Current_A = Column(float)
    Advances_Receipts_Non_Current_Q = Column(float)
    Advances_Receipts_Non_Current_TTM = Column(float)
    Short_Term_Borrowings_Financial_Institutions_A = Column(float)
    Short_Term_Borrowings_Financial_Institutions_Q = Column(float)
    Short_Term_Borrowings_Financial_Institutions_TTM = Column(float)
    Long_Term_Borrowings_Financial_Institutions_A = Column(float)
    Long_Term_Borrowings_Financial_Institutions_Q = Column(float)
    Long_Term_Borrowings_Financial_Institutions_TTM = Column(float)
    Total_Non_current_Liabilities_A = Column(float)
    Total_Non_current_Liabilities_Q = Column(float)
    Total_Non_current_Liabilities_TTM = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_A = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_Q = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_TTM = Column(float)
    Total_Assets_Turnover_A = Column(float)
    Total_Assets_Turnover_Q = Column(float)
    Total_Assets_Turnover_TTM = Column(float)
    Total_Assets_A = Column(float)
    Total_Assets_Q = Column(float)
    Total_Assets_TTM = Column(float)
    Return_Rate_on_Equity_A_percent_A = Column(float)
    Return_Rate_on_Equity_A_percent_Q = Column(float)
    Return_Rate_on_Equity_A_percent_TTM = Column(float)
    Cash_Flow_from_Operating_Ratio_A = Column(float)
    Cash_Flow_from_Operating_Ratio_Q = Column(float)
    Cash_Flow_from_Operating_Ratio_TTM = Column(float)
    Days_Payables_Outstanding_A = Column(float)
    Days_Payables_Outstanding_Q = Column(float)
    Days_Payables_Outstanding_TTM = Column(float)
    Total_Retained_Earnings_A = Column(float)
    Total_Retained_Earnings_Q = Column(float)
    Total_Retained_Earnings_TTM = Column(float)
    Capital_Reserves_A = Column(float)
    Capital_Reserves_Q = Column(float)
    Capital_Reserves_TTM = Column(float)
    Accounts_Payable_Turnover_A = Column(float)
    Accounts_Payable_Turnover_Q = Column(float)
    Accounts_Payable_Turnover_TTM = Column(float)
    Cash_Flow_from_Investing_Activities_A = Column(float)
    Cash_Flow_from_Investing_Activities_Q = Column(float)
    Cash_Flow_from_Investing_Activities_TTM = Column(float)
    Non_Operating_Income_A = Column(float)
    Non_Operating_Income_Q = Column(float)
    Non_Operating_Income_TTM = Column(float)
    Prepayments_A = Column(float)
    Prepayments_Q = Column(float)
    Prepayments_TTM = Column(float)
    Accounts_Payable_A = Column(float)
    Accounts_Payable_Q = Column(float)
    Accounts_Payable_TTM = Column(float)
    Inventory_Turnover_A = Column(float)
    Inventory_Turnover_Q = Column(float)
    Inventory_Turnover_TTM = Column(float)
    Net_Non_operating_Income_Ratio_A = Column(float)
    Net_Non_operating_Income_Ratio_Q = Column(float)
    Net_Non_operating_Income_Ratio_TTM = Column(float)
    Other_Receivables_A = Column(float)
    Other_Receivables_Q = Column(float)
    Other_Receivables_TTM = Column(float)
    Days_Receivables_Outstanding_A = Column(float)
    Days_Receivables_Outstanding_Q = Column(float)
    Days_Receivables_Outstanding_TTM = Column(float)
    Recurring_Net_Income_A = Column(float)
    Recurring_Net_Income_Q = Column(float)
    Recurring_Net_Income_TTM = Column(float)
    Intangible_Assets_A = Column(float)
    Intangible_Assets_Q = Column(float)
    Intangible_Assets_TTM = Column(float)
    Common_Stocks_A = Column(float)
    Common_Stocks_Q = Column(float)
    Common_Stocks_TTM = Column(float)
    # Common_Stock_Shares_Issued_Thousand_Shares_A = Column(float)
    # Common_Stock_Shares_Issued_Thousand_Shares_Q = Column(float)
    # Common_Stock_Shares_Issued_Thousand_Shares_TTM = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_A = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_Q = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_TTM = Column(float)
    Liabilities_Ratio_A = Column(float)
    Liabilities_Ratio_Q = Column(float)
    Liabilities_Ratio_TTM = Column(float)
    Total_Current_Liabilities_A = Column(float)
    Total_Current_Liabilities_Q = Column(float)
    Total_Current_Liabilities_TTM = Column(float)
    Debt_Equity_Ratio_A = Column(float)
    Debt_Equity_Ratio_Q = Column(float)
    Debt_Equity_Ratio_TTM = Column(float)
    Current_Ratio_A = Column(float)
    Current_Ratio_Q = Column(float)
    Current_Ratio_TTM = Column(float)
    Interest_Expense_A = Column(float)
    Interest_Expense_Q = Column(float)
    Interest_Expense_TTM = Column(float)
    Inventories_A = Column(float)
    Inventories_Q = Column(float)
    Inventories_TTM = Column(float)
    Total_Liabilities_and_Equity_A = Column(float)
    Total_Liabilities_and_Equity_Q = Column(float)
    Total_Liabilities_and_Equity_TTM = Column(float)
    Sales_Per_Share_A = Column(float)
    Sales_Per_Share_Q = Column(float)
    Sales_Per_Share_TTM = Column(float)
    Non_Controlling_Interest_A = Column(float)
    Non_Controlling_Interest_Q = Column(float)
    Non_Controlling_Interest_TTM = Column(float)
    Long_Term_Accounts_Receivable_A = Column(float)
    Long_Term_Accounts_Receivable_Q = Column(float)
    Long_Term_Accounts_Receivable_TTM = Column(float)
    Number_of_Employees_A = Column(float)
    Number_of_Employees_Q = Column(float)
    Number_of_Employees_TTM = Column(float)
    Total_Equity_Growth_Rate_A = Column(float)
    Total_Equity_Growth_Rate_Q = Column(float)
    Total_Equity_Growth_Rate_TTM = Column(float)
    Total_Fixed_Assets_A = Column(float)
    Total_Fixed_Assets_Q = Column(float)
    Total_Fixed_Assets_TTM = Column(float)
    Quick_Assets_A = Column(float)
    Quick_Assets_Q = Column(float)
    Quick_Assets_TTM = Column(float)
    Fixed_Assets_A = Column(float)
    Fixed_Assets_Q = Column(float)
    Fixed_Assets_TTM = Column(float)
    Interest_Expense_Rate_percent_A = Column(float)
    Interest_Expense_Rate_percent_Q = Column(float)
    Interest_Expense_Rate_percent_TTM = Column(float)
    Total_Operating_Cost_A = Column(float)
    Total_Operating_Cost_Q = Column(float)
    Total_Operating_Cost_TTM = Column(float)
    Equity_Turnover_A = Column(float)
    Equity_Turnover_Q = Column(float)
    Equity_Turnover_TTM = Column(float)
    Taxrate_A = Column(float)
    Taxrate_Q = Column(float)
    Taxrate_TTM = Column(float)
    Other_Accounts_Payable_A = Column(float)
    Other_Accounts_Payable_Q = Column(float)
    Other_Accounts_Payable_TTM = Column(float)
    Accounts_Receivable_Current_and_Non_Current_A = Column(float)
    Accounts_Receivable_Current_and_Non_Current_Q = Column(float)
    Accounts_Receivable_Current_and_Non_Current_TTM = Column(float)
    Sales_Per_Employee_A = Column(float)
    Sales_Per_Employee_Q = Column(float)
    Sales_Per_Employee_TTM = Column(float)
    Total_Other_Equity_Interest_A = Column(float)
    Total_Other_Equity_Interest_Q = Column(float)
    Total_Other_Equity_Interest_TTM = Column(float)
    Non_Recurring_Net_Income_A = Column(float)
    Non_Recurring_Net_Income_Q = Column(float)
    Non_Recurring_Net_Income_TTM = Column(float)
    Operating_Expenses_Ratio_A = Column(float)
    Operating_Expenses_Ratio_Q = Column(float)
    Operating_Expenses_Ratio_TTM = Column(float)
    Income_Tax_Expense_A = Column(float)
    Income_Tax_Expense_Q = Column(float)
    Income_Tax_Expense_TTM = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_A = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_Q = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_TTM = Column(float)
    Preferred_Stock_Dividends_A = Column(float)
    Preferred_Stock_Dividends_Q = Column(float)
    Preferred_Stock_Dividends_TTM = Column(float)
    Times_Interest_Earned_A = Column(float)
    Times_Interest_Earned_Q = Column(float)
    Times_Interest_Earned_TTM = Column(float)
    Days_Inventory_Outstanding_A = Column(float)
    Days_Inventory_Outstanding_Q = Column(float)
    Days_Inventory_Outstanding_TTM = Column(float)
    Preferred_Stocks_A = Column(float)
    Preferred_Stocks_Q = Column(float)
    Preferred_Stocks_TTM = Column(float)
    Cash_Flow_from_Operating_Activities_A = Column(float)
    Cash_Flow_from_Operating_Activities_Q = Column(float)
    Cash_Flow_from_Operating_Activities_TTM = Column(float)
    Total_Current_Assets_A = Column(float)
    Total_Current_Assets_Q = Column(float)
    Total_Current_Assets_TTM = Column(float)
    Depreciation_and_Amortisation_A = Column(float)
    Depreciation_and_Amortisation_Q = Column(float)
    Depreciation_and_Amortisation_TTM = Column(float)
    Advances_Receipts_Current_A = Column(float)
    Advances_Receipts_Current_Q = Column(float)
    Advances_Receipts_Current_TTM = Column(float)
    Borrowings_A = Column(float)
    Borrowings_Q = Column(float)
    Borrowings_TTM = Column(float)
    Total_Liabilities_A = Column(float)
    Total_Liabilities_Q = Column(float)
    Total_Liabilities_TTM = Column(float)
    Total_Interest_Income_A = Column(float)
    Total_Interest_Income_Q = Column(float)
    Total_Interest_Income_TTM = Column(float)
    Accounts_Receivable_A = Column(float)
    Accounts_Receivable_Q = Column(float)
    Accounts_Receivable_TTM = Column(float)
    Accounts_Receivable_Turnover_A = Column(float)
    Accounts_Receivable_Turnover_Q = Column(float)
    Accounts_Receivable_Turnover_TTM = Column(float)
    Acid_Test_A = Column(float)
    Acid_Test_Q = Column(float)
    Acid_Test_TTM = Column(float)
    Total_Operating_Expenses_A = Column(float)
    Total_Operating_Expenses_Q = Column(float)
    Total_Operating_Expenses_TTM = Column(float)
    Cash_and_Cash_Equivalent_A = Column(float)
    Cash_and_Cash_Equivalent_Q = Column(float)
    Cash_and_Cash_Equivalent_TTM = Column(float)
    Operating_Income_Per_Share_A = Column(float)
    Operating_Income_Per_Share_Q = Column(float)
    Operating_Income_Per_Share_TTM = Column(float)
    Earnings_Before_Interest_and_Tax_A = Column(float)
    Earnings_Before_Interest_and_Tax_Q = Column(float)
    Earnings_Before_Interest_and_Tax_TTM = Column(float)
    Return_on_Total_Assets_A_percent_A = Column(float)
    Return_on_Total_Assets_A_percent_Q = Column(float)
    Return_on_Total_Assets_A_percent_TTM = Column(float)
    Fixed_Asset_Turnover_A = Column(float)
    Fixed_Asset_Turnover_Q = Column(float)
    Fixed_Asset_Turnover_TTM = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_A = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_Q = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_TTM = Column(float)
    Cash_Flow_from_Financing_Activities_A = Column(float)
    Cash_Flow_from_Financing_Activities_Q = Column(float)
    Cash_Flow_from_Financing_Activities_TTM = Column(float)
    Book_Value_Per_Share_A_A = Column(float)
    Book_Value_Per_Share_A_Q = Column(float)
    Book_Value_Per_Share_A_TTM = Column(float)
    Total_Assets_Growth_Rate_A = Column(float)
    Total_Assets_Growth_Rate_Q = Column(float)
    Total_Assets_Growth_Rate_TTM = Column(float)
    # fin_date, mon_sales_date, share_date
    fin_date = Column('datetime64[ns]')
    # mon_sales_date = Column('datetime64[ns]')
    # share_date = Column('datetime64[ns]')

    extra_dims = [
        ('frequency', {'MRQ', 'MRA', 'Daily'}),
        ('period_offset', set(range(-127,1))),
    ]
    
    @classmethod
    def slice(
        cls,
        frequency: Literal['MRQ','MRA', 'Daily'],
        period_offset: int = 0

    )->'TQData':


        return super().slice(frequency=frequency, period_offset=period_offset)

TQDataSet = TQData.slice(frequency='Daily', period_offset=0)

class TQAltData(DataSetFamily):
    domain = TW_EQUITIES
    # Daily Trading Info
    Dividend_Yield_TWSE = Column(float)
    Cash_Dividend_Yield_TEJ = Column(float)
    Adjust_Factor = Column(float)
    Transaction = Column(float)
    Issue_Shares_1000_Shares = Column(float)
    PBR_TEJ = Column(float)
    Low = Column(float)
    PER_TWSE = Column(float)
    Adjust_Factor_Exclude_CashDiv = Column(float)
    Close = Column(float)
    Market_Cap_Percentage = Column(float)
    Open = Column(float)
    PBR_TWSE = Column(float)
    Last_Bid = Column(float)
    Value_Dollars = Column(float)
    High_Low_Diff = Column(float)
    Average_Trade_Price = Column(float)
    Trade_Value_Percentage = Column(float)
    High = Column(float)
    ROI = Column(float)
    Turnover = Column(float)
    PER_TEJ = Column(float)
    Last_Offer = Column(float)
    PSR_TEJ = Column(float)
    Market_Cap_Dollars = Column(float)
    Volume_1000_Shares = Column(float)
    # Trading Annotation
    Component_Stock_of_High_Dividend_Fg = Column(object)
    Matching_Period = Column(float)
    Industry = Column(object)
    Industry_Eng = Column(object)
    Sub_Industry = Column(object)  # 20231108
    Sub_Industry_Eng = Column(object) # 20231108
    Security_Type_English = Column(object)
    Component_Stock_of_MSCI_TW_Fg = Column(object)
    Suspended_Trading_Stock_Fg = Column(object)
    Attention_Stock_Fg = Column(object)
    Component_Stock_of_MidCap100_Fg = Column(object)
    Limit_Up_or_Down_in_Opening_Fg = Column(object)
    Market_Board = Column(object)
    Market_Board_Eng = Column(object)
    Security_Type_Chinese = Column(object)
    Suspension_of_Buy_After_Day_Trading_Fg = Column(object)
    Suspension_of_Sell_After_Day_Trading_Fg = Column(object)
    Limit_Up_or_Down = Column(object)
    Component_Stock_of_TPEx200_Fg = Column(object)
    Disposition_Stock_Fg = Column(object)
    Full_Delivery_Stock_Fg = Column(object)
    Component_Stock_of_TPEx50_Fg = Column(object)
    Component_Stock_of_TWN50_Fg = Column(object)

    # Institutional Shares Data
    Dealer_Hedge_Diff_Amt = Column(float)
    Total_Sell_Amt = Column(float)
    Margin_Day_Trading_Amt = Column(float)
    Total_Buy_Vol = Column(float)
    Fund_Sell_Vol = Column(float)
    Fund_Stock_Holding_Pct = Column(float)
    Dealer_Proprietary_Diff_Vol = Column(float)
    Dealer_Proprietary_Sell_Vol = Column(float)
    Margin_Short_Balance_Vol = Column(float)
    Margin_Short_Maintenance_Ratio = Column(float)
    SBL_Short_Returns_Vol = Column(float)
    Fund_Buy_Vol = Column(float)
    SBL_Short_Balance_Amt = Column(float)
    Fund_Diff_Amt = Column(float)
    SBL_Short_Sales_Vol = Column(float)
    Qfii_Stock_Holding_Pct = Column(float)
    Fund_Diff_Vol = Column(float)
    Cash_Redemption = Column(float)
    Dealer_Hedge_Diff_Vol = Column(float)
    Dealer_Stock_Holding_Pct = Column(float)
    SBL_Short_Balance_Vol = Column(float)
    Fund_Sell_Amt = Column(float)
    Margin_Purchase = Column(float)
    Qfii_Diff_Vol = Column(float)
    Total_Buy_Amt = Column(float)
    Margin_Short_Balance_Amt = Column(float)
    Margin_Short_Sales = Column(float)
    Margin_Short_Quota = Column(float)
    SBL_Short_Quota = Column(float)
    Fund_Buy_Amt = Column(float)
    Margin_Day_Trading_Vol = Column(float)
    Total_Diff_Amt = Column(float)
    Total_Sell_Vol = Column(float)
    Dealer_Hedge_Buy_Vol = Column(float)
    Qfii_Sell_Amt = Column(float)
    Dealer_Hedge_Sell_Amt = Column(float)
    SBL_Short_Sales_Amt = Column(float)
    Dealer_Proprietary_Diff_Amt = Column(float)
    Margin_Maintenance_Ratio = Column(float)
    Qfii_Buy_Vol = Column(float)
    Dealer_Proprietary_Sell_Amt = Column(float)
    Dealer_Hedge_Buy_Amt = Column(float)
    Margin_Short_Coverting = Column(float)
    Day_Trading_Volume_1000_Shares = Column(float)
    Dealer_Proprietary_Buy_Amt = Column(float)
    Margin_Balance_Amt = Column(float)
    Qfii_Buy_Amt = Column(float)
    Qfii_Sell_Vol = Column(float)
    Margin_Stock_Redemtion = Column(float)
    Qfii_Diff_Amt = Column(float)
    Account_Maintenance_Ratio = Column(float)
    Margin_Quota = Column(float)
    Margin_Balance_Vol = Column(float)
    Margin_Balance_Ratio = Column(float)
    Total_Diff_Vol = Column(float)
    Day_Trading_Pct = Column(float)
    Margin_Sale = Column(float)
    Dealer_Proprietary_Buy_Vol = Column(float)
    Dealer_Hedge_Sell_Vol = Column(float)

    # Week Share Distribution
    Custodied_Lots_Between_400_600_Pct = Column(float)
    Custodied_Larger_Than_400_Lots_Total_Lots = Column(float)
    Custodied_Greater_Than_1000_Lots_Total_Lots = Column(float)
    Custodied_Lots_Between_800_1000_Total_Holders = Column(float)
    Custodied_Lots_Between_600_800_Total_Holders = Column(float)
    Pledged_Stock_Shares_1000_Lots = Column(float)
    Custodied_Greater_Than_1000_Lots_Pct = Column(float)
    Custodied_Lots_Between_600_800_Pct = Column(float)
    Custodied_Lots_Between_800_1000_Total_Lots = Column(float)
    Total_Custodied_Shares_1000_Lots = Column(float)
    Custodied_Larger_Than_400_Lots_Total_Holders = Column(float)
    Custodied_Larger_Than_400_Lots_Pct = Column(float)
    Custodied_Under_400_Lots_Pct = Column(float)
    Custodied_Greater_Than_1000_Lots_Total_Holders = Column(float)
    Custodied_Under_400_Lots_Total_Holders = Column(float)
    Custodied_Lots_Between_800_1000_Pct = Column(float)
    Custodied_Lots_Between_600_800_Total_Lots = Column(float)
    Custodied_Under_400_Lots_Total_Lots = Column(float)
    Custodied_Lots_Between_400_600_Total_Lots = Column(float)
    Custodied_Lots_Between_400_600_Total_Holders = Column(float)

    # Monthly Sales Data
    Sales_Accu_LastYear = Column(float)
    Outstanding_Shares_1000_Shares = Column(float)
    MoM_Monthly_Sales = Column(float)
    Sales_Per_Share_Accu = Column(float)
    Month_Sales_Compared_To_Lowest_Month_Sales_MoM = Column(float)
    YoY_Accu_Sales_3M = Column(float)
    Lowest_Monthly_Sales_YM = Column('datetime64[ns]')
    YoY_AccuSales_12M = Column(float)
    Sales_Monthly = Column(float)
    MoM_Accu_Sales_3M = Column(float)
    Sales_Per_Share_Single_Month = Column(float)
    Highest_Or_Lowest_In_12M = Column(object)
    Hit_New_High_Or_Low_In_N_Months = Column(float)
    Sales_Per_Share_Accu_3M = Column(float)
    Sales_Accu_3M = Column(float)
    Highest_Or_Lowest_Same_Month = Column(object)
    Highest_Monthly_Sales_YM = Column('datetime64[ns]')
    Month_Sales_Compared_To_High_Month_Sales_MoM = Column(float)
    Lowest_Monthly_Sales = Column(float)
    Highest_Monthly_Sales = Column(float)
    Sales_Accu_3M_LastYear = Column(float)
    Sales_Accumulated = Column(float)
    YoY_Accu_Sales = Column(float)
    Sales_Accu_12M_Last_Year = Column(float)
    Sales_Accu_12M = Column(float)
    Sales_Per_Share_Accu_12M = Column(float)
    Highest_Or_Lowest_All_Time = Column(object)
    YoY_Monthly_Sales = Column(float)
    QoQ_Accu_Sales_3M = Column(float)
    Sales_Monthly_LastYear = Column(float)

    # 董監持股
    Director_and_Supervisor_Holdings_Percentage = Column(float)
    Manager_Holdings_Percentage = Column(float)
    Major_Shareholder_Holdings_Percentage_TSE = Column(float)
    Total_Director_and_Supervisor_Holdings_Percentage = Column(float)
    Managers_Total_Holdings_Percentage = Column(float)
    Major_Shareholder_Total_Holdings_Percentage_TSE = Column(float)

    mon_sales_date = Column('datetime64[ns]')
    share_date = Column('datetime64[ns]')

    extra_dims = [
        ('period_offset', set(range(-127,1))),
    ]

    @classmethod
    def slice(
        cls,
        period_offset: int = 0
    )->'TQAltData':


        return super().slice(period_offset=period_offset)

TQAltDataSet = TQAltData.slice(period_offset=0)
